# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _jarsign_opts --skip=%{_javadir} --nocopy

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/cglib/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

Name:           cglib
Version:        2.2
Release:        5.5%{?dist}
Epoch:          0
Summary:        Code Generation Library
License:        ASL 2.0
URL:            http://cglib.sourceforge.net/
Group:          Development/Libraries/Java
Source0:        http://downloads.sourceforge.net/sourceforge/cglib/cglib-src-2.2.jar
Source1:        cglib-missing-words.txt
Source2:        cglib-2.2.pom
Source22:       cglib-nodep-2.2.pom
Source3:        cglib-component-info.xml
Source4:        cglib-upload.sh
Patch0:         cglib-2.2-TestEnhancer.patch
Patch1:		cglib-build_xml.patch
Obsoletes:      %{name}-nohook < %{epoch}:%{version}-%{release}
Provides:       %{name}-nohook = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       objectweb-asm31
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  jarjar
BuildRequires:  junit
BuildRequires:  objectweb-asm >= 0:3.1
# To create content for maven2-brew
BuildRequires:  maven-deploy-plugin
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
cglib is a powerful, high performance and quality 
Code Generation Library, It is used to extend JAVA 
classes and implements interfaces at runtime.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package demo
Summary:        Samples for %{name}
Group:          Development/Documentation

%description demo
%{summary}.

%prep
%setup -q -c -n %{name}
%patch0 -p1
%patch1 -b .sav1
%{_bindir}/find -name "*.jar" | %{_bindir}/xargs -t %{__rm}

pushd lib
%{__ln_s} $(build-classpath ant) ant.jar
%{__ln_s} $(build-classpath objectweb-asm/asm) asm-3.1.jar
%{__ln_s} $(build-classpath objectweb-asm/asm-commons) asm-commons-3.1.jar
%{__ln_s} $(build-classpath objectweb-asm/asm-util) asm-util-3.1.jar
%{__ln_s} $(build-classpath jarjar) jarjar.jar
%{__ln_s} $(build-classpath junit) junit.jar
popd

( cat << EO_JP
grant codeBase "file:/-"{
  permission java.security.AllPermission;
};
EO_JP
) > java.policy

%{__cp} -p %{SOURCE1} src/test/net/sf/cglib/util/words.txt

%build
export CLASSPATH=$(build-classpath objectweb-asm/asm objectweb-asm/asm-commons objectweb-asm/asm-util jarjar junit)
export OPT_JAR_LIST=:
%{ant} -Dtest.failonerror=false jar javadoc test

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p dist/cglib-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
# Add backward compatibility cglib-nodep.jar symlink
pushd %{buildroot}%{_javadir}
%{__ln_s} %{name}-%{version}.jar %{name}-nodep-%{version}.jar
popd
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do %{__ln_s} ${jar} `/bin/echo $jar | %{__sed} "s|-%{version}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p %{SOURCE2} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap cglib cglib %{version} JPP %{name}
%add_to_maven_depmap cglib cglib-nodep %{version} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
# FIXME: (dwalluck): breaks -bi --short-circuit
%{__rm} -rf docs/api
%{__cp} -pr docs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# demo
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}-%{version}
%{__cp} -pr src/proxy/samples %{buildroot}%{_datadir}/%{name}-%{version}

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
%{__install} -p -m 755 %{SOURCE4} %{buildroot}%{repodir}/upload.sh
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH1} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}.jar %{buildroot}%{repodirlib}/cglib.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}.jar %{buildroot}%{repodirlib}/cglib-nodep.jar
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{repodirlib}/cglib.pom
%{__install} -p -m 644 %{SOURCE22} %{buildroot}%{repodirlib}/cglib-nodep.pom
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-nodep-%{version}.jar
%{_javadir}*/%{name}-nodep.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Aug 19 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.5
- Build with unsign jar (JBPAPP-6892)

* Tue May 24 2011 Yiqiao Wang <yiwang@redhat.com> - 0:2.2-5.4
- Change R objectweb-asm to R objectweb-asm31

* Tue Jan 18 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.3
- Rebuild

* Tue Dec 21 2010 Fernando Nasser <fnasser@redhat.com> - 0:2.2-5.2
- Add cglib-nodep artifact

* Mon Nov 15 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.1.1.1.2
- Add content of maven2-brew

* Mon Nov 15 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.1.1.1.1
- Add upload.sh to repolib
- Fix %%files for signed jars

* Fri May 14 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.2-5.1.1.1
- rebuilt

* Tue Apr 20 2010 Hui Wang <huwang@redhat.com> 0:2.2-5.1.1
- Rebuild to generate signed jar

* Thu Mar 11 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.2-5.1
- Merge from RHEL-4-EP-5

* Wed Mar 10 2010 David Walluck <dwalluck@redhat.com> 0:2.2-5
- add depmap frag for cglib-nodep
- version nodep jar

* Wed Sep 2 2009 Martha Benitez <mbenitez@redhat.com> 0:2.2-4
- Add patch to include version in manifest.mf
- Add pom.xml file to repolib

* Wed Jul 15 2009 Fernando Nasser <fnasser@redhat.com> 0:2.2-3
- Add backward compatibility cglib-nodep.jar symlink

* Wed Jul 08 2009 David Walluck <dwalluck@redhat.com> 0:2.2-2
- remove hook/nohook distinction
- add pom

* Tue Jul 07 2009 David Walluck <dwalluck@redhat.com> 0:2.2-1
- 2.2

* Thu Oct 09 2008 David Walluck <dwalluck@redhat.com> 0:2.1.3-4
- fix repolib

* Sat Jun 21 2008 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-3
- Rebuild for JPP 5.0

* Tue Apr 15 2008 David Walluck <dwalluck@redhat.com> 0:2.1.3-2jpp.ep1.3
- fix cglib-debug output directory in TestAll.java

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1.3-2jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp.ep1.1
- Rebuild

* Thu Mar 08 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp.el4ep1.4
- Make aspectwerks optional (run-time)

* Fri Feb 19 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1.3-2jpp.el4ep1.3
- Add -brew suffix

* Fri Feb 16 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1.3-2jpp.el4ep1.2
- Change name of repository directory in component-info.xml and in the spec

* Fri Feb 16 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1.3-2jpp.el4ep1.1
- Add repolib support

* Tue Feb 28 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp_3rh
- Rebuild

* Tue Feb 28 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp_2rh
- Rebuild in full

* Tue Feb 21 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp_1rh
- First Red Hat build -- without hook for bootstraping jmock

* Fri Feb 17 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.1.3-2jpp
- Create option --without hook to build without requiring aspectwerkz
- Create new subpackage cglib-nohook containing cglib-nohook.jar
- Main package also provides cglib-nohook
- Add demo subpackage

* Fri Nov 11 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.3-1jpp
- Upgrade to 2.1_3
- asm2 is BuildRequired too, because our newer jarjar needs it

* Tue Mar 15 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.0-1jpp
- Adapt to upgraded asm 1.5.3 (no src patching required)

* Tue Feb 01 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.0.2-2jpp
- Adapt to upgraded asm 1.4.3 (patch required)

* Wed Sep 08 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.2-1jpp
- Upgrade to 2.0.2 (bug fix required)
- Drop cglib-full.jar (identical to cglib.jar in our build)
- Add manual generated offline with "maven xdoc:transform"

* Tue Sep 07 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-3jpp
- Include cglib-full.jar in package

* Mon Sep 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-2jpp
- Upgrade to Ant 1.6.X
- Build with ant-1.6.2
- Relax some versioned dependencies
- Add missing BuildReq junit
- Upgraded to 2.0.1 and built with aspectwerkz-0.9 on Sat Jun 12 2004 
  by Ralph Apel <r.apel at r-apel.de> as 0:2.0.1-1jpp

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-3jpp
- Build with ant-1.6.2
- Dropped ant from CLASSPATH
- Relaxed jpackage-utils BuildReq

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.0-2jpp
- Upgrade to Ant 1.6.X

* Sat Feb 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-1jpp
- First JPackage release
